Package org.apache.catalina.connector

# Class Request

java.lang.Object
org.apache.catalina.connector.Request

All Implemented Interfaces:
  `HttpServletRequest`, `ServletRequest`

public class Request extends Object implements HttpServletRequest
Wrapper object for the Coyote request.

Author:
  Remy Maucherat, Craig R. McClanahan

## Field Summary

Fields
Modifier and Type
Field
Description
`protected Boolean`
`asyncSupported`
`protected String`
`authType`
Authentication type.
`protected static final int`
`CACHED_POST_LEN`
Post data buffer.
`protected final Connector`
`connector`
Associated Catalina connector.
`protected Cookie[]`
`cookies`
The set of cookies associated with this Request.
`protected boolean`
`cookiesConverted`
Cookie parsed flag.
`protected boolean`
`cookiesParsed`
Cookie headers parsed flag.
`protected Request`
`coyoteRequest`
Coyote request.
`protected static final Locale`
`defaultLocale`
The default Locale if none are specified.
`protected RequestFacade`
`facade`
The facade associated with this request.
`protected FilterChain`
`filterChain`
Filter chain associated with the request.
`protected final InputBuffer`
`inputBuffer`
The associated input buffer.
`protected CoyoteInputStream`
`inputStream`
ServletInputStream.
`protected DispatcherType`
`internalDispatcherType`
The current dispatcher type.
`protected String`
`localAddr`
Local address
`protected final ArrayList<Locale>`
`locales`
The preferred Locales associated with this Request.
`protected boolean`
`localesParsed`
Parse locales.
`protected String`
`localName`
Local address
`protected int`
`localPort`
Local port
`protected final MappingData`
`mappingData`
Mapping data.
`protected ParameterMap<String,String[]>`
`parameterMap`
Hash map used in the getParametersMap method.
`protected boolean`
`parametersParsed`
Request parameters parsed flag.
`protected Collection<Part>`
`parts`
The parts, if any, uploaded with this request.
`protected Exception`
`partsParseException`
The exception thrown, if any when parsing the parts.
`protected String`
`peerAddr`
Connection peer address.
`protected byte[]`
`postData`
`protected CoyoteReader`
`reader`
Reader.
`protected String`
`remoteAddr`
Remote address.
`protected String`
`remoteHost`
Remote host.
`protected int`
`remotePort`
Remote port
`protected Object`
`requestDispatcherPath`
The current request dispatcher path.
`protected boolean`
`requestedSessionCookie`
Was the requested session ID received in a cookie?
`protected String`
`requestedSessionId`
The requested session ID (if any) for this request.
`protected boolean`
`requestedSessionSSL`
Was the requested session ID obtained from the SSL session?
`protected boolean`
`requestedSessionURL`
Was the requested session ID received in a URL?
`protected Response`
`response`
The response with which this request is associated.
`protected boolean`
`secure`
Secure flag.
`protected Session`
`session`
The currently active session for this request.
`protected static final StringManager`
`sm`
The string manager for this package.
`protected boolean`
`sslAttributesParsed`
Flag that indicates if SSL attributes have been parsed to improve performance for applications (usually frameworks) that make multiple calls to `getAttributeNames()`.
`protected Subject`
`subject`
The Subject associated with the current AccessControlContext
`protected B2CConverter`
`URIConverter`
URI byte to char converter.
`protected Principal`
`userPrincipal`
User principal.
`protected boolean`
`usingInputStream`
Using stream flag.
`protected boolean`
`usingReader`
Using reader flag.

### Fields inherited from interface jakarta.servlet.http.HttpServletRequest

`BASIC_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH, FORM_AUTH`

## Constructor Summary

Constructors
Constructor
Description
`Request(Connector connector)`
Create a new Request object associated with the given Connector.

## Method Summary

Modifier and Type
Method
Description
`void`
`addCookie(Cookie cookie)`
Add a Cookie to the set of Cookies associated with this Request.
`void`
`addLocale(Locale locale)`
Add a Locale to the set of preferred Locales for this Request.
`protected void`
`addPathParameter(String name, String value)`
`boolean`
`authenticate(HttpServletResponse response)`
Triggers the same authentication process as would be triggered if the request is for a resource that is protected by a security constraint.
`String`
`changeSessionId()`
Changes the session ID of the session associated with this request.
`void`
`changeSessionId(String newSessionId)`
Change the ID of the session that this request is associated with.
`protected void`
`checkSwallowInput()`
Check the configuration for aborted uploads and if configured to do so, disable the swallowing of any remaining input and close the connection once the response has been written.
`void`
`clearCookies()`
Clear the collection of Cookies associated with this Request.
`void`
`clearLocales()`
Clear the collection of Locales associated with this Request.
`protected void`
`convertCookies()`
Converts the parsed cookies (parsing the Cookie headers first if they have not been parsed) into Cookie objects.
`ServletInputStream`
`createInputStream()`
Create and return a ServletInputStream to read the content associated with this Request.
`protected Session`
`doGetSession(boolean create)`
`void`
`finishRequest()`
Perform whatever actions are required to flush and close the input stream or reader, in a single operation.
`AsyncContext`
`getAsyncContext()`
Get the current AsyncContext.
`AsyncContextImpl`
`getAsyncContextInternal()`
`Object`
`getAttribute(String name)`
Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.
`Enumeration<String>`
`getAttributeNames()`
Returns an `Enumeration` containing the names of the attributes available to this request.
`String`
`getAuthType()`
Returns the name of the authentication scheme used to protect the servlet.
`String`
`getCharacterEncoding()`
Returns the name of the character encoding used in the body of this request.
`Connector`
`getConnector()`
`int`
`getContentLength()`
Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known.
`long`
`getContentLengthLong()`
Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known.
`String`
`getContentType()`
Returns the MIME type of the body of the request, or `null` if the type is not known.
`Context`
`getContext()`
Return the Context within which this Request is being processed.
`String`
`getContextPath()`
Returns the portion of the request URI that indicates the context of the request.
`Cookie[]`
`getCookies()`
Returns an array containing all of the `Cookie` objects the client sent with this request.
`Request`
`getCoyoteRequest()`
Get the Coyote request.
`long`
`getDateHeader(String name)`
Returns the value of the specified request header as a `long` value that represents a `Date` object.
`String`
`getDecodedRequestURI()`
Get the decoded request URI.
`MessageBytes`
`getDecodedRequestURIMB()`
Get the decoded request URI.
`boolean`
`getDiscardFacades()`
Get the recycling strategy of the facade objects.
`DispatcherType`
`getDispatcherType()`
`FilterChain`
`getFilterChain()`
Get filter chain associated with the request.
`String`
`getHeader(String name)`
Returns the value of the specified request header as a `String`.
`Enumeration<String>`
`getHeaderNames()`
Returns an enumeration of all the header names this request contains.
`Enumeration<String>`
`getHeaders(String name)`
Returns all the values of the specified request header as an `Enumeration` of `String` objects.
`Host`
`getHost()`
`HttpServletMapping`
`getHttpServletMapping()`
Obtain the mapping information for this request.
`ServletInputStream`
`getInputStream()`
Retrieves the body of the request as binary data using a `ServletInputStream`.
`int`
`getIntHeader(String name)`
Returns the value of the specified request header as an `int`.
`String`
`getLocalAddr()`
Returns the Internet Protocol (IP) address of the interface on which the request was received.
`Locale`
`getLocale()`
Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header.
`Enumeration<Locale>`
`getLocales()`
Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header.
`String`
`getLocalName()`
Returns the host name of the Internet Protocol (IP) interface on which the request was received.
`int`
`getLocalPort()`
Returns the Internet Protocol (IP) port number of the interface on which the request was received.
`MappingData`
`getMappingData()`
`String`
`getMethod()`
Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT.
`Object`
`getNote(String name)`
`String`
`getParameter(String name)`
Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist.
`Map<String,String[]>`
`getParameterMap()`
Returns a `Map` of the parameters of this request.
`Enumeration<String>`
`getParameterNames()`
Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request.
`String[]`
`getParameterValues(String name)`
Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.
`Part`
`getPart(String name)`
Gets the named Part or null if the Part does not exist.
`Collection<Part>`
`getParts()`
Return a collection of all uploaded Parts.
`String`
`getPathInfo()`
Returns any extra path information associated with the URL the client sent when it made this request.
`protected String`
`getPathParameter(String name)`
`String`
`getPathTranslated()`
Returns any extra path information after the servlet name but before the query string, and translates it to a real path.
`String`
`getPeerAddr()`
`Principal`
`getPrincipal()`
`String`
`getProtocol()`
Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1.
`String`
`getProtocolRequestId()`
Obtain the request identifier for this request as defined by the protocol in use.
`String`
`getQueryString()`
Returns the query string that is contained in the request URL after the path.
`BufferedReader`
`getReader()`
Retrieves the body of the request as character data using a `BufferedReader`.
`String`
`getRemoteAddr()`
Returns the Internet Protocol (IP) address of the client or last proxy that sent the request.
`String`
`getRemoteHost()`
Returns the fully qualified name of the client or the last proxy that sent the request.
`int`
`getRemotePort()`
Returns the Internet Protocol (IP) source port of the client or last proxy that sent the request.
`String`
`getRemoteUser()`
Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated.
`HttpServletRequest`
`getRequest()`
`RequestDispatcher`
`getRequestDispatcher(String path)`
Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path.
`String`
`getRequestedSessionId()`
Returns the session ID specified by the client.
`String`
`getRequestId()`
Obtain a unique (within the lifetime of the Servlet container) identifier string for this request.
`MessageBytes`
`getRequestPathMB()`
Get the request path.
`String`
`getRequestURI()`
Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request.
`StringBuffer`
`getRequestURL()`
Reconstructs the URL the client used to make the request.
`Response`
`getResponse()`
`String`
`getScheme()`
Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`.
`ServerCookies`
`getServerCookies()`
Return the server representation of the cookies associated with this request.
`String`
`getServerName()`
Returns the host name of the server to which the request was sent.
`int`
`getServerPort()`
Returns the port number to which the request was sent.
`ServletConnection`
`getServletConnection()`
Obtain details of the network connection to the Servlet container that is being used by this request.
`ServletContext`
`getServletContext()`
`String`
`getServletPath()`
Returns the part of this request's URL that calls the servlet.
`HttpSession`
`getSession()`
Returns the current session associated with this request, or if the request does not have a session, creates one.
`HttpSession`
`getSession(boolean create)`
Returns the current `HttpSession` associated with this request or, if there is no current session and `create` is true, returns a new session.
`Session`
`getSessionInternal()`
`Session`
`getSessionInternal(boolean create)`
`InputStream`
`getStream()`
`Map<String,String>`
`getTrailerFields()`
Obtain a Map of the trailer fields that is not backed by the request object.
`protected B2CConverter`
`getURIConverter()`
`Principal`
`getUserPrincipal()`
Returns a `java.security.Principal` object containing the name of the current authenticated user.
`Wrapper`
`getWrapper()`
`boolean`
`isAsync()`
`boolean`
`isAsyncCompleting()`
`boolean`
`isAsyncDispatching()`
`boolean`
`isAsyncStarted()`
`boolean`
`isAsyncSupported()`
`boolean`
`isFinished()`
`boolean`
`isParametersParsed()`
`boolean`
`isRequestedSessionIdFromCookie()`
Checks whether the requested session ID came in as a cookie.
`boolean`
`isRequestedSessionIdFromURL()`
Checks whether the requested session ID came in as part of the request URL.
`boolean`
`isRequestedSessionIdValid()`
Checks whether the requested session ID is still valid.
`boolean`
`isSecure()`
Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.
`boolean`
`isTrailerFieldsReady()`
Are trailer fields ready to be read (there may still be no trailers to read).
`boolean`
`isUserInRole(String role)`
Returns a boolean indicating whether the authenticated user is included in the specified logical "role".
`void`
`login(String username, String password)`
Authenticate the provided user name and password and then associated the authenticated user with the request.
`void`
`logout()`
Removes any authenticated user from the request.
`PushBuilder`
`newPushBuilder()`
Obtain a builder for generating push requests.
`PushBuilder`
`newPushBuilder(HttpServletRequest request)`
`protected void`
`parseCookies()`
Parse cookies.
`protected void`
`parseLocales()`
Parse request locales.
`protected void`
`parseLocalesHeader(String value, TreeMap<Double,ArrayList<Locale>> locales)`
Parse accept-language header value.
`protected void`
`parseParameters()`
Parse request parameters.
`protected byte[]`
`readChunkedPostBody()`
Read chunked post body.
`protected int`
`readPostBody(byte[] body, int len)`
Deprecated.
Unused.
`protected void`
`readPostBodyFully(byte[] body, int len)`
Read post body into an array.
`void`
`recycle()`
Release all object references, and initialize instance variables, in preparation for reuse of this object.
`protected void`
`recycleCookieInfo(boolean recycleCoyote)`
`protected void`
`recycleSessionInfo()`
`void`
`removeAttribute(String name)`
Removes an attribute from this request.
`void`
`removeNote(String name)`
Remove any object bound to the specified name in the internal notes for this request.
`void`
`setAsyncSupported(boolean asyncSupported)`
`void`
`setAttribute(String name, Object value)`
Stores an attribute in this request.
`void`
`setAuthType(String type)`
Set the authentication type used for this request, if any; otherwise set the type to `null`.
`void`
`setCharacterEncoding(String enc)`
Overrides the name of the character encoding used in the body of this request.
`void`
`setContentType(String contentType)`
Set the content type for this Request.
`void`
`setCoyoteRequest(Request coyoteRequest)`
Set the Coyote request.
`void`
`setFilterChain(FilterChain filterChain)`
Set filter chain associated with the request.
`void`
`setLocalPort(int port)`
Set the port number of the server to process this request.
`void`
`setNote(String name, Object value)`
Bind an object to a specified name in the internal notes associated with this request, replacing any existing binding for this name.
`void`
`setPathInfo(String path)`
Set the path information for this Request.
`void`
`setRemoteAddr(String remoteAddr)`
Set the IP address of the remote client associated with this Request.
`void`
`setRemoteHost(String remoteHost)`
Set the fully qualified name of the remote client associated with this Request.
`void`
`setRequest(HttpServletRequest applicationRequest)`
Set a wrapped HttpServletRequest to pass to the application.
`void`
`setRequestedSessionCookie(boolean flag)`
Set a flag indicating whether or not the requested session ID for this request came in through a cookie.
`void`
`setRequestedSessionId(String id)`
Set the requested session ID for this request.
`void`
`setRequestedSessionSSL(boolean flag)`
Set a flag indicating whether or not the requested session ID for this request came in through SSL.
`void`
`setRequestedSessionURL(boolean flag)`
Set a flag indicating whether or not the requested session ID for this request came in through a URL.
`void`
`setResponse(Response response)`
Set the Response with which this Request is associated.
`void`
`setSecure(boolean secure)`
Set the value to be returned by `isSecure()` for this Request.
`void`
`setServerPort(int port)`
Set the port number of the server to process this request.
`protected void`
`setURIConverter(B2CConverter URIConverter)`
Set the URI converter.
`void`
`setUserPrincipal(Principal principal)`
Set the Principal who has been authenticated for this Request.
`AsyncContext`
`startAsync()`
`AsyncContext`
`startAsync(ServletRequest request, ServletResponse response)`
`protected String`
`unescape(String s)`
`<T extends HttpUpgradeHandler>
T`
`upgrade(Class<T> httpUpgradeHandlerClass)`
Start the HTTP upgrade process and create and instance of the provided protocol handler class.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### coyoteRequest

protected Request coyoteRequest
Coyote request.

### sm

protected static final StringManager sm
The string manager for this package.

### cookies

protected Cookie[] cookies
The set of cookies associated with this Request.

### defaultLocale

protected static final Locale defaultLocale
The default Locale if none are specified.

### sslAttributesParsed

protected boolean sslAttributesParsed
Flag that indicates if SSL attributes have been parsed to improve performance for applications (usually frameworks) that make multiple calls to `getAttributeNames()`.

### locales

protected final ArrayList<Locale> locales
The preferred Locales associated with this Request.

### authType

protected String authType
Authentication type.

### internalDispatcherType

protected DispatcherType internalDispatcherType
The current dispatcher type.

### inputBuffer

protected final InputBuffer inputBuffer
The associated input buffer.

### inputStream

protected CoyoteInputStream inputStream
ServletInputStream.

### reader

protected CoyoteReader reader
Reader.

### usingInputStream

protected boolean usingInputStream
Using stream flag.

### usingReader

protected boolean usingReader
Using reader flag.

### userPrincipal

protected Principal userPrincipal
User principal.

### parametersParsed

protected boolean parametersParsed
Request parameters parsed flag.

### cookiesParsed

protected boolean cookiesParsed
Cookie headers parsed flag. Indicates that the cookie headers have been parsed into ServerCookies.

### cookiesConverted

protected boolean cookiesConverted
Cookie parsed flag. Indicates that the ServerCookies have been converted into user facing Cookie objects.

### secure

protected boolean secure
Secure flag.

### subject

protected transient Subject subject
The Subject associated with the current AccessControlContext

### CACHED_POST_LEN

protected static final int CACHED_POST_LEN
Post data buffer.

See Also:
  - Constant Field Values

### postData

protected byte[] postData

### parameterMap

protected ParameterMap<String,String[]> parameterMap
Hash map used in the getParametersMap method.

### parts

protected Collection<Part> parts
The parts, if any, uploaded with this request.

### partsParseException

protected Exception partsParseException
The exception thrown, if any when parsing the parts.

### session

protected Session session
The currently active session for this request.

### requestDispatcherPath

protected Object requestDispatcherPath
The current request dispatcher path.

### requestedSessionCookie

protected boolean requestedSessionCookie
Was the requested session ID received in a cookie?

### requestedSessionId

protected String requestedSessionId
The requested session ID (if any) for this request.

### requestedSessionURL

protected boolean requestedSessionURL
Was the requested session ID received in a URL?

### requestedSessionSSL

protected boolean requestedSessionSSL
Was the requested session ID obtained from the SSL session?

### localesParsed

protected boolean localesParsed
Parse locales.

### localPort

protected int localPort
Local port

### remoteAddr

protected String remoteAddr
Remote address.

### peerAddr

protected String peerAddr
Connection peer address.

### remoteHost

protected String remoteHost
Remote host.

### remotePort

protected int remotePort
Remote port

### localAddr

protected String localAddr
Local address

### localName

protected String localName
Local address

### asyncSupported

protected Boolean asyncSupported

### connector

protected final Connector connector
Associated Catalina connector.

### filterChain

protected FilterChain filterChain
Filter chain associated with the request.

### mappingData

protected final MappingData mappingData
Mapping data.

### facade

protected RequestFacade facade
The facade associated with this request.

### response

protected Response response
The response with which this request is associated.

### URIConverter

protected B2CConverter URIConverter
URI byte to char converter.

## Constructor Details

### Request

public Request(Connector connector)
Create a new Request object associated with the given Connector.

Parameters:
  `connector` - The Connector with which this Request object will always be associated. In normal usage this must be non-null. In some test scenarios, it may be possible to use a null Connector without triggering an NPE.

## Method Details

### setCoyoteRequest

public void setCoyoteRequest(Request coyoteRequest)
Set the Coyote request.

Parameters:
  `coyoteRequest` - The Coyote request

### getCoyoteRequest

public Request getCoyoteRequest()
Get the Coyote request.

Returns:
  the Coyote request object

### addPathParameter

protected void addPathParameter(String name, String value)

### getPathParameter

protected String getPathParameter(String name)

### setAsyncSupported

public void setAsyncSupported(boolean asyncSupported)

### recycle

public void recycle()
Release all object references, and initialize instance variables, in preparation for reuse of this object.

### recycleSessionInfo

protected void recycleSessionInfo()

### recycleCookieInfo

protected void recycleCookieInfo(boolean recycleCoyote)

### getConnector

public Connector getConnector()

Returns:
  the Connector through which this Request was received.

### getContext

public Context getContext()
Return the Context within which this Request is being processed.

This is available as soon as the appropriate Context is identified. Note that availability of a Context allows `getContextPath()` to return a value, and thus enables parsing of the request URI.

Returns:
  the Context mapped with the request

### getDiscardFacades

public boolean getDiscardFacades()
Get the recycling strategy of the facade objects.

Returns:
  the value of the flag as set on the connector, or `true` if no connector is associated with this request

### getFilterChain

public FilterChain getFilterChain()
Get filter chain associated with the request.

Returns:
  the associated filter chain

### setFilterChain

public void setFilterChain(FilterChain filterChain)
Set filter chain associated with the request.

Parameters:
  `filterChain` - new filter chain

### getHost

public Host getHost()

Returns:
  the Host within which this Request is being processed.

### getMappingData

public MappingData getMappingData()

Returns:
  mapping data.

### getRequest

public HttpServletRequest getRequest()

Returns:
  the `ServletRequest` for which this object is the facade. This method must be implemented by a subclass.

### setRequest

public void setRequest(HttpServletRequest applicationRequest)
Set a wrapped HttpServletRequest to pass to the application. Components wishing to wrap the request should obtain the request via `getRequest()`, wrap it and then call this method with the wrapped request.

Parameters:
  `applicationRequest` - The wrapped request to pass to the application

### getResponse

public Response getResponse()

Returns:
  the Response with which this Request is associated.

### setResponse

public void setResponse(Response response)
Set the Response with which this Request is associated.

Parameters:
  `response` - The new associated response

### getStream

public InputStream getStream()

Returns:
  the input stream associated with this Request.

### getURIConverter

protected B2CConverter getURIConverter()

Returns:
  the URI converter.

### setURIConverter

protected void setURIConverter(B2CConverter URIConverter)
Set the URI converter.

Parameters:
  `URIConverter` - the new URI converter

### getWrapper

public Wrapper getWrapper()

Returns:
  the Wrapper within which this Request is being processed.

### createInputStream

public ServletInputStream createInputStream() throws IOException
Create and return a ServletInputStream to read the content associated with this Request.

Returns:
  the created input stream
Throws:
  `IOException` - if an input/output error occurs

### finishRequest

public void finishRequest() throws IOException
Perform whatever actions are required to flush and close the input stream or reader, in a single operation.

Throws:
  `IOException` - if an input/output error occurs

### getNote

public Object getNote(String name)

Parameters:
  `name` - Name of the note to be returned
Returns:
  the object bound with the specified name to the internal notes for this request, or `null` if no such binding exists.

### removeNote

public void removeNote(String name)
Remove any object bound to the specified name in the internal notes for this request.

Parameters:
  `name` - Name of the note to be removed

### setLocalPort

public void setLocalPort(int port)
Set the port number of the server to process this request.

Parameters:
  `port` - The server port

### setNote

public void setNote(String name, Object value)
Bind an object to a specified name in the internal notes associated with this request, replacing any existing binding for this name.

Parameters:
  `name` - Name to which the object should be bound
  `value` - Object to be bound to the specified name

### setRemoteAddr

public void setRemoteAddr(String remoteAddr)
Set the IP address of the remote client associated with this Request.

Parameters:
  `remoteAddr` - The remote IP address

### setRemoteHost

public void setRemoteHost(String remoteHost)
Set the fully qualified name of the remote client associated with this Request.

Parameters:
  `remoteHost` - The remote host name

### setSecure

public void setSecure(boolean secure)
Set the value to be returned by `isSecure()` for this Request.

Parameters:
  `secure` - The new isSecure value

### setServerPort

public void setServerPort(int port)
Set the port number of the server to process this request.

Parameters:
  `port` - The server port

### getAttribute

public Object getAttribute(String name)
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.

Attributes can be set two ways. The servlet container may set attributes to make available custom information about a request. For example, for requests made using HTTPS, the attribute `jakarta.servlet.request.X509Certificate` can be used to retrieve information on the certificate of the client. Attributes can also be set programmatically using `ServletRequest.setAttribute(java.lang.String, java.lang.Object)`. This allows information to be embedded into a request before a `RequestDispatcher` call.

Attribute names should follow the same conventions as package names. Names beginning with `jakarta.*` are reserved for use by the Jakarta EE platform.

Specified by:
  `getAttribute` in interface `ServletRequest`
Parameters:
  `name` - a `String` specifying the name of the attribute
Returns:
  an `Object` containing the value of the attribute, or `null` if the attribute does not exist

### getContentLengthLong

public long getContentLengthLong()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_LENGTH.

Specified by:
  `getContentLengthLong` in interface `ServletRequest`
Returns:
  a long integer containing the length of the request body or -1 if the length is not known

### getAttributeNames

public Enumeration<String> getAttributeNames()
Returns an `Enumeration` containing the names of the attributes available to this request. This method returns an empty `Enumeration` if the request has no attributes available to it.

The attribute names returned will only be those for the attributes set via `setAttribute(String, Object)`. Tomcat internal attributes will not be included although they are accessible via `getAttribute(String)`. The Tomcat internal attributes include:

- `Globals.DISPATCHER_TYPE_ATTR`
- `Globals.DISPATCHER_REQUEST_PATH_ATTR`
- `Globals.ASYNC_SUPPORTED_ATTR`
- `Globals.CERTIFICATES_ATTR` (SSL connections only)
- `Globals.CIPHER_SUITE_ATTR` (SSL connections only)
- `Globals.KEY_SIZE_ATTR` (SSL connections only)
- `Globals.SSL_SESSION_ID_ATTR` (SSL connections only)
- `Globals.SSL_SESSION_MGR_ATTR` (SSL connections only)
- `Globals.PARAMETER_PARSE_FAILED_ATTR`

The underlying connector may also expose request attributes. These all have names starting with "org.apache.tomcat" and include:

- `Globals.SENDFILE_SUPPORTED_ATTR`

Connector implementations may return some, all or none of these attributes and may also support additional attributes.

Specified by:
  `getAttributeNames` in interface `ServletRequest`
Returns:
  an `Enumeration` of strings containing the names of the request's attributes

### getCharacterEncoding

public String getCharacterEncoding()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the name of the character encoding used in the body of this request. This method returns `null` if the no character encoding has been specified. The following priority order is used to determine the specified encoding:

1. per request
2. web application default via the deployment descriptor or `ServletContext.setRequestCharacterEncoding(String)`
3. container default via container specific configuration

Specified by:
  `getCharacterEncoding` in interface `ServletRequest`
Returns:
  a `String` containing the name of the character encoding, or `null` if the request does not specify a character encoding

### getContentLength

public int getContentLength()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_LENGTH.

Specified by:
  `getContentLength` in interface `ServletRequest`
Returns:
  an integer containing the length of the request body or -1 if the length is not known or is greater than `Integer.MAX_VALUE`

### getContentType

public String getContentType()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the MIME type of the body of the request, or `null` if the type is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_TYPE.

Specified by:
  `getContentType` in interface `ServletRequest`
Returns:
  a `String` containing the name of the MIME type of the request, or null if the type is not known

### setContentType

public void setContentType(String contentType)
Set the content type for this Request.

Parameters:
  `contentType` - The content type

### getInputStream

public ServletInputStream getInputStream() throws IOException
Description copied from interface: `jakarta.servlet.ServletRequest`
Retrieves the body of the request as binary data using a `ServletInputStream`. Either this method or `ServletRequest.getReader()` may be called to read the body, not both.

Specified by:
  `getInputStream` in interface `ServletRequest`
Returns:
  a `ServletInputStream` object containing the body of the request
Throws:
  `IOException` - if an input or output exception occurred

### getLocale

public Locale getLocale()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns the default locale for the server.

Specified by:
  `getLocale` in interface `ServletRequest`
Returns:
  the preferred `Locale` for the client

### getLocales

public Enumeration<Locale> getLocales()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns an `Enumeration` containing one `Locale`, the default locale for the server.

Specified by:
  `getLocales` in interface `ServletRequest`
Returns:
  an `Enumeration` of preferred `Locale` objects for the client

### getParameter

public String getParameter(String name)
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use `ServletRequest.getParameterValues(java.lang.String)`.

If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by `getParameterValues`.

If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via `ServletRequest.getInputStream()` or `ServletRequest.getReader()` can interfere with the execution of this method.

Specified by:
  `getParameter` in interface `ServletRequest`
Parameters:
  `name` - Name of the desired request parameter
Returns:
  the value of the specified request parameter, if any; otherwise, return `null`. If there is more than one value defined, return only the first one.
See Also:
  - `ServletRequest.getParameterValues(java.lang.String)`

### getParameterMap

public Map<String,String[]> getParameterMap()
Returns a `Map` of the parameters of this request. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

Specified by:
  `getParameterMap` in interface `ServletRequest`
Returns:
  A `Map` containing parameter names as keys and parameter values as map values.

### getParameterNames

public Enumeration<String> getParameterNames()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request. If the request has no parameters, the method returns an empty `Enumeration`.

Specified by:
  `getParameterNames` in interface `ServletRequest`
Returns:
  the names of all defined request parameters for this request.

### getParameterValues

public String[] getParameterValues(String name)
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.

If the parameter has a single value, the array has a length of 1.

Specified by:
  `getParameterValues` in interface `ServletRequest`
Parameters:
  `name` - Name of the desired request parameter
Returns:
  the defined values for the specified request parameter, if any; otherwise, return `null`.
See Also:
  - `ServletRequest.getParameter(java.lang.String)`

### getProtocol

public String getProtocol()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1. For HTTP servlets, the value returned is the same as the value of the CGI variable `SERVER_PROTOCOL`.

Specified by:
  `getProtocol` in interface `ServletRequest`
Returns:
  a `String` containing the protocol name and version number

### getReader

public BufferedReader getReader() throws IOException
Description copied from interface: `jakarta.servlet.ServletRequest`
Retrieves the body of the request as character data using a `BufferedReader`. The reader translates the character data according to the character encoding used on the body. Either this method or `ServletRequest.getInputStream()` may be called to read the body, not both.

Specified by:
  `getReader` in interface `ServletRequest`
Returns:
  a `BufferedReader` containing the body of the request
Throws:
  `IOException` - if an input or output exception occurred
See Also:
  - `ServletRequest.getInputStream()`

### getRemoteAddr

public String getRemoteAddr()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the Internet Protocol (IP) address of the client or last proxy that sent the request. For HTTP servlets, same as the value of the CGI variable `REMOTE_ADDR`.

Specified by:
  `getRemoteAddr` in interface `ServletRequest`
Returns:
  a `String` containing the IP address of the client that sent the request

### getPeerAddr

public String getPeerAddr()

Returns:
  the connection peer IP address making this Request.

### getRemoteHost

public String getRemoteHost()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the fully qualified name of the client or the last proxy that sent the request. If the engine cannot or chooses not to resolve the hostname (to improve performance), this method returns the dotted-string form of the IP address. For HTTP servlets, same as the value of the CGI variable `REMOTE_HOST`.

Specified by:
  `getRemoteHost` in interface `ServletRequest`
Returns:
  a `String` containing the fully qualified name of the client

### getRemotePort

public int getRemotePort()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the Internet Protocol (IP) source port of the client or last proxy that sent the request.

Specified by:
  `getRemotePort` in interface `ServletRequest`
Returns:
  an integer specifying the port number

### getLocalName

public String getLocalName()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the host name of the Internet Protocol (IP) interface on which the request was received.

Specified by:
  `getLocalName` in interface `ServletRequest`
Returns:
  a `String` containing the host name of the IP on which the request was received.

### getLocalAddr

public String getLocalAddr()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the Internet Protocol (IP) address of the interface on which the request was received.

Specified by:
  `getLocalAddr` in interface `ServletRequest`
Returns:
  a `String` containing the IP address on which the request was received.

### getLocalPort

public int getLocalPort()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the Internet Protocol (IP) port number of the interface on which the request was received.

Specified by:
  `getLocalPort` in interface `ServletRequest`
Returns:
  an integer specifying the port number

### getRequestDispatcher

public RequestDispatcher getRequestDispatcher(String path)
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path. A `RequestDispatcher` object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

The pathname specified may be relative, although it cannot extend outside the current servlet context. If the path begins with a "/" it is interpreted as relative to the current context root. This method returns `null` if the servlet container cannot return a `RequestDispatcher`.

The difference between this method and `ServletContext.getRequestDispatcher(java.lang.String)` is that this method can take a relative path.

Specified by:
  `getRequestDispatcher` in interface `ServletRequest`
Parameters:
  `path` - a `String` specifying the pathname to the resource. If it is relative, it must be relative against the current servlet.
Returns:
  a `RequestDispatcher` object that acts as a wrapper for the resource at the specified path, or `null` if the servlet container cannot return a `RequestDispatcher`
See Also:
  - `RequestDispatcher`
  - `ServletContext.getRequestDispatcher(java.lang.String)`

### getScheme

public String getScheme()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`. Different schemes have different rules for constructing URLs, as noted in RFC 1738.

Specified by:
  `getScheme` in interface `ServletRequest`
Returns:
  a `String` containing the name of the scheme used to make this request

### getServerName

public String getServerName()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the host name of the server to which the request was sent. It is the value of the part before ":" in the `Host` header value, if any, or the resolved server name, or the server IP address.

Specified by:
  `getServerName` in interface `ServletRequest`
Returns:
  a `String` containing the name of the server

### getServerPort

public int getServerPort()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns the port number to which the request was sent. It is the value of the part after ":" in the `Host` header value, if any, or the server port where the client connection was accepted on.

Specified by:
  `getServerPort` in interface `ServletRequest`
Returns:
  an integer specifying the port number

### isSecure

public boolean isSecure()
Description copied from interface: `jakarta.servlet.ServletRequest`
Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.

Specified by:
  `isSecure` in interface `ServletRequest`
Returns:
  a boolean indicating if the request was made using a secure channel

### removeAttribute

public void removeAttribute(String name)
Description copied from interface: `jakarta.servlet.ServletRequest`
Removes an attribute from this request. This method is not generally needed as attributes only persist as long as the request is being handled.

Attribute names should follow the same conventions as package names. Names beginning with `jakarta.*` are reserved for use by the Jakarta EE platform.

Specified by:
  `removeAttribute` in interface `ServletRequest`
Parameters:
  `name` - a `String` specifying the name of the attribute to remove

### setAttribute

public void setAttribute(String name, Object value)
Description copied from interface: `jakarta.servlet.ServletRequest`
Stores an attribute in this request. Attributes are reset between requests. This method is most often used in conjunction with `RequestDispatcher`.

Attribute names should follow the same conventions as package names. Names beginning with `jakarta.*` are reserved for use by the Jakarta EE platform.

If the object passed in is null, the effect is the same as calling `ServletRequest.removeAttribute(java.lang.String)`.
It is warned that when the request is dispatched from the servlet resides in a different web application by `RequestDispatcher`, the object set by this method may not be correctly retrieved in the caller servlet.

Specified by:
  `setAttribute` in interface `ServletRequest`
Parameters:
  `name` - a `String` specifying the name of the attribute
  `value` - the `Object` to be stored

### setCharacterEncoding

public void setCharacterEncoding(String enc) throws UnsupportedEncodingException
Description copied from interface: `jakarta.servlet.ServletRequest`
Overrides the name of the character encoding used in the body of this request. This method must be called prior to reading request parameters or reading input using getReader().

Specified by:
  `setCharacterEncoding` in interface `ServletRequest`
Parameters:
  `enc` - a `String` containing the name of the character encoding
Throws:
  `UnsupportedEncodingException` - if this is not a valid encoding

### getServletContext

public ServletContext getServletContext()

Specified by:
  `getServletContext` in interface `ServletRequest`
Returns:
  TODO

### startAsync

public AsyncContext startAsync()

Specified by:
  `startAsync` in interface `ServletRequest`
Returns:
  TODO

### startAsync

public AsyncContext startAsync(ServletRequest request, ServletResponse response)

Specified by:
  `startAsync` in interface `ServletRequest`
Parameters:
  `request` - The ServletRequest with which to initialise the asynchronous context
  `response` - The ServletResponse with which to initialise the asynchronous context
Returns:
  TODO

### isAsyncStarted

public boolean isAsyncStarted()

Specified by:
  `isAsyncStarted` in interface `ServletRequest`
Returns:
  TODO

### isAsyncDispatching

public boolean isAsyncDispatching()

### isAsyncCompleting

public boolean isAsyncCompleting()

### isAsync

public boolean isAsync()

### isAsyncSupported

public boolean isAsyncSupported()

Specified by:
  `isAsyncSupported` in interface `ServletRequest`
Returns:
  TODO

### getAsyncContext

public AsyncContext getAsyncContext()
Description copied from interface: `jakarta.servlet.ServletRequest`
Get the current AsyncContext.

Specified by:
  `getAsyncContext` in interface `ServletRequest`
Returns:
  The current AsyncContext

### getAsyncContextInternal

public AsyncContextImpl getAsyncContextInternal()

### getDispatcherType

public DispatcherType getDispatcherType()

Specified by:
  `getDispatcherType` in interface `ServletRequest`
Returns:
  TODO

### getRequestId

public String getRequestId()
Description copied from interface: `jakarta.servlet.ServletRequest`
Obtain a unique (within the lifetime of the Servlet container) identifier string for this request.

There is no defined format for this string. The format is implementation dependent.

Specified by:
  `getRequestId` in interface `ServletRequest`
Returns:
  A unique identifier for the request

### getProtocolRequestId

public String getProtocolRequestId()
Description copied from interface: `jakarta.servlet.ServletRequest`
Obtain the request identifier for this request as defined by the protocol in use. Note that some protocols do not define such an identifier.

Examples of protocol provided request identifiers include:

HTTP 1.x
  None, so the empty string should be returned
HTTP 2
  The stream identifier
HTTP 3
  The stream identifier
AJP
  None, so the empty string should be returned

Specified by:
  `getProtocolRequestId` in interface `ServletRequest`
Returns:
  The request identifier if one is defined, otherwise an empty string

### getServletConnection

public ServletConnection getServletConnection()
Description copied from interface: `jakarta.servlet.ServletRequest`
Obtain details of the network connection to the Servlet container that is being used by this request. The information presented may differ from information presented elsewhere in the Servlet API as raw information is presented without adjustments for, example, use of reverse proxies that may be applied elsewhere in the Servlet API.

Specified by:
  `getServletConnection` in interface `ServletRequest`
Returns:
  The network connection details.

### addCookie

public void addCookie(Cookie cookie)
Add a Cookie to the set of Cookies associated with this Request.

Parameters:
  `cookie` - The new cookie

### addLocale

public void addLocale(Locale locale)
Add a Locale to the set of preferred Locales for this Request. The first added Locale will be the first one returned by getLocales().

Parameters:
  `locale` - The new preferred Locale

### clearCookies

public void clearCookies()
Clear the collection of Cookies associated with this Request.

### clearLocales

public void clearLocales()
Clear the collection of Locales associated with this Request.

### setAuthType

public void setAuthType(String type)
Set the authentication type used for this request, if any; otherwise set the type to `null`. Typical values are "BASIC", "DIGEST", or "SSL".

Parameters:
  `type` - The authentication type used

### setPathInfo

public void setPathInfo(String path)
Set the path information for this Request. This will normally be called when the associated Context is mapping the Request to a particular Wrapper.

Parameters:
  `path` - The path information

### setRequestedSessionCookie

public void setRequestedSessionCookie(boolean flag)
Set a flag indicating whether or not the requested session ID for this request came in through a cookie. This is normally called by the HTTP Connector, when it parses the request headers.

Parameters:
  `flag` - The new flag

### setRequestedSessionId

public void setRequestedSessionId(String id)
Set the requested session ID for this request. This is normally called by the HTTP Connector, when it parses the request headers.

Parameters:
  `id` - The new session id

### setRequestedSessionURL

public void setRequestedSessionURL(boolean flag)
Set a flag indicating whether or not the requested session ID for this request came in through a URL. This is normally called by the HTTP Connector, when it parses the request headers.

Parameters:
  `flag` - The new flag

### setRequestedSessionSSL

public void setRequestedSessionSSL(boolean flag)
Set a flag indicating whether or not the requested session ID for this request came in through SSL. This is normally called by the HTTP Connector, when it parses the request headers.

Parameters:
  `flag` - The new flag

### getDecodedRequestURI

public String getDecodedRequestURI()
Get the decoded request URI.

Returns:
  the URL decoded request URI

### getDecodedRequestURIMB

public MessageBytes getDecodedRequestURIMB()
Get the decoded request URI.

Returns:
  the URL decoded request URI

### setUserPrincipal

public void setUserPrincipal(Principal principal)
Set the Principal who has been authenticated for this Request. This value is also used to calculate the value to be returned by the `getRemoteUser()` method.

Parameters:
  `principal` - The user Principal

### isTrailerFieldsReady

public boolean isTrailerFieldsReady()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Are trailer fields ready to be read (there may still be no trailers to read). This method always returns `true` if the underlying protocol does not support trailer fields. Otherwise, `true` is returned once all of the following are true:

- The application has ready all the request data and an EOF has been received or the content-length is zero
- All trailer fields, if any, have been received

Specified by:
  `isTrailerFieldsReady` in interface `HttpServletRequest`
Returns:
  `true` if trailers are ready to be read

### getTrailerFields

public Map<String,String> getTrailerFields()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Obtain a Map of the trailer fields that is not backed by the request object.

Specified by:
  `getTrailerFields` in interface `HttpServletRequest`
Returns:
  A Map of the received trailer fields with all keys lower case or an empty Map if no trailers are present

### newPushBuilder

public PushBuilder newPushBuilder()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Obtain a builder for generating push requests. `PushBuilder` documents how this request will be used as the basis for a push request. Each call to this method will return a new instance, independent of any previous instance obtained.

Specified by:
  `newPushBuilder` in interface `HttpServletRequest`
Returns:
  A builder that can be used to generate push requests based on this request or `null` if push is not supported. Note that even if a PushBuilder instance is returned, by the time that `PushBuilder.push()` is called, it may no longer be valid to push a request and the push request will be ignored.

### newPushBuilder

public PushBuilder newPushBuilder(HttpServletRequest request)

### upgrade

public <T extends HttpUpgradeHandler> T upgrade(Class<T> httpUpgradeHandlerClass) throws IOException, ServletException
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Start the HTTP upgrade process and create and instance of the provided protocol handler class. The connection will be passed this instance once the current request/response pair has completed processing. Calling this method sets the response status to `HttpServletResponse.SC_SWITCHING_PROTOCOLS`.

Specified by:
  `upgrade` in interface `HttpServletRequest`
Type Parameters:
  `T` - The type of the upgrade handler
Parameters:
  `httpUpgradeHandlerClass` - The class that implements the upgrade handler
Returns:
  A newly created instance of the specified upgrade handler type
Throws:
  `IOException` - if an I/O error occurred during the upgrade
  `ServletException` - if the given httpUpgradeHandlerClass fails to be instantiated

### getAuthType

public String getAuthType()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the name of the authentication scheme used to protect the servlet. All servlet containers support basic, form and client certificate authentication, and may additionally support digest authentication. If the servlet is not authenticated `null` is returned.

Same as the value of the CGI variable AUTH_TYPE.

Specified by:
  `getAuthType` in interface `HttpServletRequest`
Returns:
  one of the static members BASIC_AUTH, FORM_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH (suitable for == comparison) or the container-specific string indicating the authentication scheme, or `null` if the request was not authenticated.

### getContextPath

public String getContextPath()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the portion of the request URI that indicates the context of the request. The context path always comes first in a request URI. The path starts with a "/" character but does not end with a "/" character. For servlets in the default (root) context, this method returns "". The container does not decode this string.

Specified by:
  `getContextPath` in interface `HttpServletRequest`
Returns:
  a `String` specifying the portion of the request URI that indicates the context of the request

### getCookies

public Cookie[] getCookies()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns an array containing all of the `Cookie` objects the client sent with this request. This method returns `null` if no cookies were sent.

Specified by:
  `getCookies` in interface `HttpServletRequest`
Returns:
  an array of all the `Cookies` included with this request, or `null` if the request has no cookies

### getServerCookies

public ServerCookies getServerCookies()
Return the server representation of the cookies associated with this request. Triggers parsing of the Cookie HTTP headers (but not conversion to Cookie objects) if the headers have not yet been parsed.

Returns:
  the server cookies

### getDateHeader

public long getDateHeader(String name)
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the value of the specified request header as a `long` value that represents a `Date` object. Use this method with headers that contain dates, such as `If-Modified-Since`.

The date is returned as the number of milliseconds since January 1, 1970 GMT. The header name is case insensitive.

If the request did not have a header of the specified name, this method returns -1. If the header can't be converted to a date, the method throws an `IllegalArgumentException`.

Specified by:
  `getDateHeader` in interface `HttpServletRequest`
Parameters:
  `name` - a `String` specifying the name of the header
Returns:
  a `long` value representing the date specified in the header expressed as the number of milliseconds since January 1, 1970 GMT, or -1 if the named header was not included with the request

### getHeader

public String getHeader(String name)
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the value of the specified request header as a `String`. If the request did not include a header of the specified name, this method returns `null`. If there are multiple headers with the same name, this method returns the first head in the request. The header name is case insensitive. You can use this method with any request header.

Specified by:
  `getHeader` in interface `HttpServletRequest`
Parameters:
  `name` - a `String` specifying the header name
Returns:
  a `String` containing the value of the requested header, or `null` if the request does not have a header of that name

### getHeaders

public Enumeration<String> getHeaders(String name)
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns all the values of the specified request header as an `Enumeration` of `String` objects.

Some headers, such as `Accept-Language` can be sent by clients as several headers each with a different value rather than sending the header as a comma separated list.

If the request did not include any headers of the specified name, this method returns an empty `Enumeration`. The header name is case insensitive. You can use this method with any request header.

Specified by:
  `getHeaders` in interface `HttpServletRequest`
Parameters:
  `name` - a `String` specifying the header name
Returns:
  an `Enumeration` containing the values of the requested header. If the request does not have any headers of that name return an empty enumeration. If the container does not allow access to header information, return null

### getHeaderNames

public Enumeration<String> getHeaderNames()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns an enumeration of all the header names this request contains. If the request has no headers, this method returns an empty enumeration.

Some servlet containers do not allow servlets to access headers using this method, in which case this method returns `null`

Specified by:
  `getHeaderNames` in interface `HttpServletRequest`
Returns:
  an enumeration of all the header names sent with this request; if the request has no headers, an empty enumeration; if the servlet container does not allow servlets to use this method, `null`

### getIntHeader

public int getIntHeader(String name)
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the value of the specified request header as an `int`. If the request does not have a header of the specified name, this method returns -1. If the header cannot be converted to an integer, this method throws a `NumberFormatException`.

The header name is case insensitive.

Specified by:
  `getIntHeader` in interface `HttpServletRequest`
Parameters:
  `name` - a `String` specifying the name of a request header
Returns:
  an integer expressing the value of the request header or -1 if the request doesn't have a header of this name

### getHttpServletMapping

public HttpServletMapping getHttpServletMapping()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Obtain the mapping information for this request.

Specified by:
  `getHttpServletMapping` in interface `HttpServletRequest`
Returns:
  the mapping information for this request

### getMethod

public String getMethod()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT. Same as the value of the CGI variable REQUEST_METHOD.

Specified by:
  `getMethod` in interface `HttpServletRequest`
Returns:
  a `String` specifying the name of the method with which this request was made

### getPathInfo

public String getPathInfo()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns any extra path information associated with the URL the client sent when it made this request. The extra path information follows the servlet path but precedes the query string and will start with a "/" character.

This method returns `null` if there was no extra path information.

The URL will be canonicalized as per section 3.5 of the specification before the path information, if any, is extracted.

Specified by:
  `getPathInfo` in interface `HttpServletRequest`
Returns:
  a `String`, canonicalized by the web container, specifying extra path information that comes after the servlet path but before the query string in the request URL; or `null` if the URL does not have any extra path information

### getPathTranslated

public String getPathTranslated()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns any extra path information after the servlet name but before the query string, and translates it to a real path. Same as the value of the CGI variable PATH_TRANSLATED.

If the URL does not have any extra path information, this method returns `null` or the servlet container cannot translate the virtual path to a real path for any reason (such as when the web application is executed from an archive). The web container does not decode this string.

Specified by:
  `getPathTranslated` in interface `HttpServletRequest`
Returns:
  a `String` specifying the real path, or `null` if the URL does not have any extra path information

### getQueryString

public String getQueryString()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the query string that is contained in the request URL after the path. This method returns `null` if the URL does not have a query string. Same as the value of the CGI variable QUERY_STRING.

Specified by:
  `getQueryString` in interface `HttpServletRequest`
Returns:
  a `String` containing the query string or `null` if the URL contains no query string. The value is not decoded by the container.

### getRemoteUser

public String getRemoteUser()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated. Whether the user name is sent with each subsequent request depends on the browser and type of authentication. Same as the value of the CGI variable REMOTE_USER.

Specified by:
  `getRemoteUser` in interface `HttpServletRequest`
Returns:
  a `String` specifying the login of the user making this request, or `null` if the user login is not known

### getRequestPathMB

public MessageBytes getRequestPathMB()
Get the request path.

Returns:
  the request path

### getRequestedSessionId

public String getRequestedSessionId()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the session ID specified by the client. This may not be the same as the ID of the current valid session for this request. If the client did not specify a session ID, this method returns `null`.

Specified by:
  `getRequestedSessionId` in interface `HttpServletRequest`
Returns:
  a `String` specifying the session ID, or `null` if the request did not specify a session ID
See Also:
  - `HttpServletRequest.isRequestedSessionIdValid()`

### getRequestURI

public String getRequestURI()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request. The web container does not decode this String. For example:

Examples of Returned Values
First line of HTTP request | Returned Value
--- | ---
POST /some/path.html HTTP/1.1 |  | /some/path.html
GET http://foo.bar/a.html HTTP/1.0 |  | /a.html
HEAD /xyz?a=b HTTP/1.1 |  | /xyz

To reconstruct a URL with a scheme and host, use `HttpServletRequest.getRequestURL()`.

Specified by:
  `getRequestURI` in interface `HttpServletRequest`
Returns:
  a `String` containing the part of the URL from the protocol name up to the query string
See Also:
  - `HttpServletRequest.getRequestURL()`

### getRequestURL

public StringBuffer getRequestURL()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and server path, but it does not include query string parameters.

Because this method returns a `StringBuffer`, not a string, you can modify the URL easily, for example, to append query parameters.

This method is useful for creating redirect messages and for reporting errors.

Specified by:
  `getRequestURL` in interface `HttpServletRequest`
Returns:
  a `StringBuffer` object containing the reconstructed URL

### getServletPath

public String getServletPath()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the part of this request's URL that calls the servlet. This path starts with a "/" character and includes either the servlet name or a path to the servlet, but does not include any extra path information or a query string. Same as the value of the CGI variable SCRIPT_NAME.

The URL will be canonicalized as per section 3.5 of the specification before the path information, if any, is extracted.

This method will return an empty string ("") if the servlet used to process this request was matched using the "/*" pattern.

Specified by:
  `getServletPath` in interface `HttpServletRequest`
Returns:
  a `String`, canonicalized by the web container, containing the name or path of the servlet being called, as specified in the request URL, or an empty string if the servlet used to process the request is matched using the "/*" pattern.

### getSession

public HttpSession getSession()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the current session associated with this request, or if the request does not have a session, creates one.

Specified by:
  `getSession` in interface `HttpServletRequest`
Returns:
  the `HttpSession` associated with this request
See Also:
  - `HttpServletRequest.getSession(boolean)`

### getSession

public HttpSession getSession(boolean create)
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns the current `HttpSession` associated with this request or, if there is no current session and `create` is true, returns a new session.

If `create` is `false` and the request has no valid `HttpSession`, this method returns `null`.

To make sure the session is properly maintained, you must call this method before the response is committed. If the container is using cookies to maintain session integrity and is asked to create a new session when the response is committed, an IllegalStateException is thrown.

Specified by:
  `getSession` in interface `HttpServletRequest`
Parameters:
  `create` - `true` to create a new session for this request if necessary; `false` to return `null` if there's no current session
Returns:
  the `HttpSession` associated with this request or `null` if `create` is `false` and the request has no valid session
See Also:
  - `HttpServletRequest.getSession()`

### isRequestedSessionIdFromCookie

public boolean isRequestedSessionIdFromCookie()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Checks whether the requested session ID came in as a cookie.

Specified by:
  `isRequestedSessionIdFromCookie` in interface `HttpServletRequest`
Returns:
  `true` if the session ID came in as a cookie; otherwise, `false`
See Also:
  - `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdFromURL

public boolean isRequestedSessionIdFromURL()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Checks whether the requested session ID came in as part of the request URL.

Specified by:
  `isRequestedSessionIdFromURL` in interface `HttpServletRequest`
Returns:
  `true` if the session ID came in as part of a URL; otherwise, `false`
See Also:
  - `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdValid

public boolean isRequestedSessionIdValid()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Checks whether the requested session ID is still valid.

Specified by:
  `isRequestedSessionIdValid` in interface `HttpServletRequest`
Returns:
  `true` if this request has an id for a valid session in the current session context; `false` otherwise
See Also:
  - `HttpServletRequest.getRequestedSessionId()`
  - `HttpServletRequest.getSession(boolean)`

### isUserInRole

public boolean isUserInRole(String role)
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns a boolean indicating whether the authenticated user is included in the specified logical "role". Roles and role membership can be defined using deployment descriptors. If the user has not been authenticated, the method returns `false`.

Specified by:
  `isUserInRole` in interface `HttpServletRequest`
Parameters:
  `role` - a `String` specifying the name of the role
Returns:
  a `boolean` indicating whether the user making this request belongs to a given role; `false` if the user has not been authenticated

### getPrincipal

public Principal getPrincipal()

Returns:
  the principal that has been authenticated for this Request.

### getUserPrincipal

public Principal getUserPrincipal()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Returns a `java.security.Principal` object containing the name of the current authenticated user. If the user has not been authenticated, the method returns `null`.

Specified by:
  `getUserPrincipal` in interface `HttpServletRequest`
Returns:
  a `java.security.Principal` containing the name of the user making this request; `null` if the user has not been authenticated

### getSessionInternal

public Session getSessionInternal()

Returns:
  the session associated with this Request, creating one if necessary.

### changeSessionId

public void changeSessionId(String newSessionId)
Change the ID of the session that this request is associated with. There are several things that may trigger an ID change. These include moving between nodes in a cluster and session fixation prevention during the authentication process.

Parameters:
  `newSessionId` - The session to change the session ID for

### changeSessionId

public String changeSessionId()
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Changes the session ID of the session associated with this request. This method does not create a new session object it only changes the ID of the current session.

Specified by:
  `changeSessionId` in interface `HttpServletRequest`
Returns:
  the new session ID allocated to the session
See Also:
  - `HttpSessionIdListener`

### getSessionInternal

public Session getSessionInternal(boolean create)

Parameters:
  `create` - Create a new session if one does not exist
Returns:
  the session associated with this Request, creating one if necessary and requested.

### isParametersParsed

public boolean isParametersParsed()

Returns:
  `true` if we have parsed parameters

### isFinished

public boolean isFinished()

Returns:
  `true` if an attempt has been made to read the request body and all of the request body has been read.

### checkSwallowInput

protected void checkSwallowInput()
Check the configuration for aborted uploads and if configured to do so, disable the swallowing of any remaining input and close the connection once the response has been written.

### authenticate

public boolean authenticate(HttpServletResponse response) throws IOException, ServletException
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Triggers the same authentication process as would be triggered if the request is for a resource that is protected by a security constraint.

Specified by:
  `authenticate` in interface `HttpServletRequest`
Parameters:
  `response` - The response to use to return any authentication challenge
Returns:
  `true` if the user is successfully authenticated and `false` if not
Throws:
  `IOException` - if the authentication process attempted to read from the request or write to the response and an I/O error occurred
  `ServletException` - if the authentication failed and the caller is expected to handle the failure

### login

public void login(String username, String password) throws ServletException
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Authenticate the provided user name and password and then associated the authenticated user with the request.

Specified by:
  `login` in interface `HttpServletRequest`
Parameters:
  `username` - The user name to authenticate
  `password` - The password to use to authenticate the user
Throws:
  `ServletException` - If any of `HttpServletRequest.getRemoteUser()`, `HttpServletRequest.getUserPrincipal()` or `HttpServletRequest.getAuthType()` are non-null, if the configured authenticator does not support user name and password authentication or if the authentication fails

### logout

public void logout() throws ServletException
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Removes any authenticated user from the request.

Specified by:
  `logout` in interface `HttpServletRequest`
Throws:
  `ServletException` - If the logout fails

### getParts

public Collection<Part> getParts() throws IOException, IllegalStateException, ServletException
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Return a collection of all uploaded Parts.

Specified by:
  `getParts` in interface `HttpServletRequest`
Returns:
  A collection of all uploaded Parts.
Throws:
  `IOException` - if an I/O error occurs
  `IllegalStateException` - if size limits are exceeded or no multipart configuration is provided
  `ServletException` - if the request is not multipart/form-data

### getPart

public Part getPart(String name) throws IOException, IllegalStateException, ServletException
Description copied from interface: `jakarta.servlet.http.HttpServletRequest`
Gets the named Part or null if the Part does not exist. Triggers upload of all Parts.

Specified by:
  `getPart` in interface `HttpServletRequest`
Parameters:
  `name` - The name of the Part to obtain
Returns:
  The named Part or null if the Part does not exist
Throws:
  `IOException` - if an I/O error occurs
  `IllegalStateException` - if size limits are exceeded
  `ServletException` - if the request is not multipart/form-data

### doGetSession

protected Session doGetSession(boolean create)

### unescape

protected String unescape(String s)

### parseCookies

protected void parseCookies()
Parse cookies. This only parses the cookies into the memory efficient ServerCookies structure. It does not populate the Cookie objects.

### convertCookies

protected void convertCookies()
Converts the parsed cookies (parsing the Cookie headers first if they have not been parsed) into Cookie objects.

### parseParameters

protected void parseParameters()
Parse request parameters.

### readPostBody

@Deprecated protected int readPostBody(byte[] body, int len) throws IOException
Deprecated.
Unused. Will be removed in Tomcat 11.0.x onwards. Use `readPostBodyFully(byte[], int)`
Read post body into an array.

Parameters:
  `body` - The bytes array in which the body will be read
  `len` - The body length
Returns:
  the bytes count that has been read
Throws:
  `IOException` - if an IO exception occurred

### readPostBodyFully

protected void readPostBodyFully(byte[] body, int len) throws IOException
Read post body into an array.

Parameters:
  `body` - The bytes array in which the body will be read
  `len` - The body length
Throws:
  `IOException` - if an IO exception occurred or EOF is reached before the body has been fully read

### readChunkedPostBody

protected byte[] readChunkedPostBody() throws IOException
Read chunked post body.

Returns:
  the post body as a bytes array
Throws:
  `IOException` - if an IO exception occurred

### parseLocales

protected void parseLocales()
Parse request locales.

### parseLocalesHeader

protected void parseLocalesHeader(String value, TreeMap<Double,ArrayList<Locale>> locales)
Parse accept-language header value.

Parameters:
  `value` - the header value
  `locales` - the map that will hold the result